
Name:          documancer
Version:       0.2.4
Release:       1
Source:        %{name}-%{version}.tar.gz

Prefix:        /usr
Summary:       Programmer's documentation reader
License:       GPL
Group:         Development/Other
URL:           http://documancer.sourceforge.net
Packager:      Vaclav Slavik <vaclav.slavik@matfyz.cz>
BuildRoot:     /var/tmp/%{name}-%{version}-root

Requires:      perl, swish-e, wget
Requires:      wxPython >= 2.4.0
Requires:      wxmozilla-python >= 0.5.3
Requires:      python >= 2.3

%description
Documancer is programmer's documentation browser with fulltext searching.
It has several advantages over using web browser or specialized format-specific
viewers (such as info):

 * Unified UI for all documentation formats (currently only HTML and man and 
   info pages are supported)
 * The GUI is better suited for documentation reading that generic web browser
 * Documancer can create fulltext index for the docs and enables the user
   to quickly search it
 * Bookmarks and indexes are manual-specific, which reduces false matches and
   chaos in bookmarks


%prep
%setup -q

%build
CFLAGS="%{optflags}" CXXFLAGS="%{optflags}" ./configure --prefix=%{prefix}
%make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# install KDE & GNOME menus:
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applnk/Development
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
install -m 644 etc/documancer.desktop $RPM_BUILD_ROOT%{_datadir}/applnk/Development
install -m 644 etc/documancer.desktop $RPM_BUILD_ROOT%{_datadir}/applications

# install KDE icons:
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/{16x16,32x32,48x48}/apps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps
install -m 644 src/data/documancer-16.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/documancer.png
install -m 644 src/data/documancer-32.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/documancer.png
install -m 644 src/data/documancer-32.png $RPM_BUILD_ROOT%{_datadir}/pixmaps/documancer.png
install -m 644 src/data/documancer.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps

# install Mandrake menu:
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/menu
cat > $RPM_BUILD_ROOT/%{_libdir}/menu/documancer <<EOF 
?package(%{name}): \
	command="%{_bindir}/documancer"\\
	needs="X11"\\
	section="Applications/Development/Tools"\\
	icon="documancer.png"\\
	title="Documancer"\\
	longtitle="Documentation reader"
EOF


%post
# This is done on Mandrake to update its menus:
if [ -x /usr/bin/update-menus ]; then /usr/bin/update-menus || true ; fi

%postun
# This is done on Mandrake to update its menus:
if [ "$1" = "0" -a -x /usr/bin/update-menus ]; then /usr/bin/update-menus || true ; fi



%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc FAQ NEWS README TODO AUTHORS COPYING
%{_bindir}/*
%dir %{_libdir}/documancer
%{_libdir}/documancer/*
%{_datadir}/pixmaps/*
%{_libdir}/menu/*
%{_datadir}/applnk/*/*
%{_datadir}/applications/*
%{_datadir}/icons/*/*/apps/*
